'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

require('../index');

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('arrayAssist', function () {

  it('removeFirstOne', function () {
    var arr = [1, 2, 3];
    var result = arr.removeFirstOne();
    _assert2.default.strictEqual(result[0], 2);
    _assert2.default.strictEqual(result[1], 3);
  });

  it('removeLastOne1', function () {
    var arr = [1, 2, 3];
    var result = arr.removeLastOne();
    _assert2.default.strictEqual(result[0], 1);
    _assert2.default.strictEqual(result[1], 2);
  });

  it('removeLastOne2', function () {
    var arr = [1];
    var result = arr.removeLastOne();
    _assert2.default.strictEqual(result.length, 0);
  });

  it('removeStart', function () {
    var arr = [1, 2, 3];
    var result = arr.removeStart(2);
    _assert2.default.strictEqual(result[0], 3);
  });

  it('removeEnd', function () {
    var arr = [1, 2, 3];
    var result = arr.removeEnd(2);
    _assert2.default.strictEqual(result[0], 1);
  });

  it('deepCopy', function () {
    var arr = [1, 2, 3];
    var a = arr.deepCopy();
    a[1] = 4;
    _assert2.default.strictEqual(arr[1], 2);
  });

  it('removeByIndex', function () {
    var arr = [1, 2, 3];
    var result = arr.removeByIndex(2);
    // logger.error(arr, result)
    _assert2.default.strictEqual(result[0], 1);
    _assert2.default.strictEqual(result[1], 2);
    _assert2.default.strictEqual(result[2], undefined);
    _assert2.default.strictEqual(arr[2], 3);
  });

  it('removeByValue', function () {
    var arr = [1, 2, 3];
    var result = arr.removeByValue(3);
    _assert2.default.strictEqual(result[0], 1);
    _assert2.default.strictEqual(result[1], 2);
    _assert2.default.strictEqual(result[2], undefined);
    _assert2.default.strictEqual(arr[2], 3);
  });

  it('removeByValue', function () {
    var arr = [1, 2, 3];
    try {
      var result = arr.removeByValue(4);
    } catch (err) {
      _assert2.default.strictEqual(typeof err === 'undefined' ? 'undefined' : _typeof(err), 'object');
    }
  });

  it('append', function () {
    var arr = [1, 2, 3];
    var result = arr.append([4, 5]);
    _assert2.default.strictEqual(result[0], 1);
    _assert2.default.strictEqual(result[3], 4);
  });

  it('getMax', function () {
    var arr = [1, '2', 3];
    var result = arr.getMax();
    _assert2.default.strictEqual(result['value'], '3');
    _assert2.default.strictEqual(result['index'].length, 1);
    _assert2.default.strictEqual(result['index'][0], 2);
  });

  it('getMax 1', function () {
    var arr = [1, '1', 1];
    var result = arr.getMax();
    // logger.error(result['index'])
    _assert2.default.strictEqual(result['value'], '1');
    _assert2.default.strictEqual(result['index'].length, 3);
  });

  it('getMin', function () {
    var arr = ['1', 2, '3'];
    var result = arr.getMin();
    _assert2.default.strictEqual(result['value'], '1');
    _assert2.default.strictEqual(result['index'][0], 0);
    _assert2.default.strictEqual(result['index'][1], undefined);
  });

  it('getSum', function () {
    var arr = ['1', 2, '3'];
    var result = arr.getSum();
    _assert2.default.strictEqual(result, '6');
  });

  it('select', function () {
    var arr = ['1', 2, '3', 6, 9, 2];
    var result = arr.select([0, 3, 5]);
    // logger.error(result)
    _assert2.default.strictEqual(result[0], '1');
    _assert2.default.strictEqual(result[1], 6);
    _assert2.default.strictEqual(result[2], 2);
  });

  it('toLowerCase', function () {
    var arr = ['drG', 2, '3', 6, 9, 2];
    var result = arr.toLowerCase();
    // logger.error(result)
    _assert2.default.strictEqual(result[0], 'drg');
  });

  it('random', function () {
    var arr = [2];
    var result = arr.random();
    logger.error(result);
    // assert.strictEqual(result[0], 'drg')
  });

  it('numberArrayToHexString', function () {
    var arr = [224, 220, 74, 72];
    var result = arr.numberArrayToHexString();
    // logger.error(result)
    _assert2.default.strictEqual(result, 'E0DC4A48');
  });
});